; Advanced firmware V1.0 for Elektor LPT-DMX convertor

; Copyright (C) 2004 Tommy Sools (www.sools.com).
; All rights are reserved.

; Thanks go out to Benot BOUCHEZ for developing
; Elektor's LPT-DMX interface and programming its
; original firmware.

;;; License agreement ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; You are free to program this firmware in any chip no
; matter whether it is for commercial or non-commercial
; purposes. Even money may be charged for the actual
; work of programming this firmware into the chip,
; however it must be made clear to people where the
; software could freely be obtained.

; You may also make modifications to this firmware. If
; you distribute modified versions of this firmware, it
; must be made clear to users that they are dealing
; with a modified version of this firmware and not the
; original one written by Tommy Sools. No money can be
; charged for modified versions of this firmware.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Made for 8 MHz quartz.

; There is 1 clock tick in 1 cycle,
; so 1 cycle lasts 0,125 microsec.

; To be safe, 10 bytes will be reserved for stack
; (at least 6 bytes are really required).

;;; Notes related to errata ;;;;;;;;;;;;;;;;;;;;;;;;;;;

; On revision B and C processors, R0 is corrupted if
; using NOP directly after STS. R0 and STS are never
; used however.

; On revision B and C processors, the source register
; is corrupted if using NOP directly after LDS. LDS
; is never used however.

; On revision B and C processors, LDS and STS mustn't
; be used directly after skip instructions. STS and
; LDS are never used however.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.equ    mcu_8515 = 1
.equ    mcu_8535 = 1

.include "8535def.inc"
.include "8515definitions.inc"
.include "8515macros.inc"
.include "main.inc"
