.include "avrdmxdefinitions.inc"

.macro skip_if_not_str_flipflop
    SBIC    PIND,STR
.endmacro

.macro skip_if_str_flipflop
    SBIS    PIND,STR
.endmacro

.macro skip_if_str
    SBIS    PIND,STR
.endmacro

.macro skip_if_not_str
    SBIC    PIND,STR
.endmacro

.macro reset_str_flipflop
; Make BUSY line low
    CBI     PORTA,BUSY
.endmacro

.macro reset_error_led
; Reset error led
    SBI     PORTA,_LEDERR
.endmacro

.macro set_error_led
; Set error led
    CBI     PORTA,_LEDERR
.endmacro

.macro store_parallel_data
; Store DATA from parallel port in buffer
    IN      rdata,PINC
.endmacro

.macro set_ack
; Enable ACK
    CBI     PORTA,_ACK
.endmacro

.macro reset_ack
; Disable ACK
    SBI     PORTA,_ACK      ; 2 cycles
.endmacro

.macro set_pe
; Enable PE
    SBI     PORTA,PE
.endmacro

.macro reset_pe
; Disable PE
    CBI     PORTA,PE
.endmacro

.macro set_sel
; Enable SEL
    SBI     PORTB,SEL
.endmacro

.macro reset_sel
; Disable SEL
    CBI     PORTB,SEL
.endmacro

.macro set_err
; Enable ERR
    CBI     PORTA,_ERR
.endmacro

.macro reset_err
; Disable ERR
    SBI     PORTA,_ERR
.endmacro

.macro set_txd
    SBI     PORTD,TXD
.endmacro

.macro reset_txd
    CBI     PORTD,TXD
.endmacro

.macro skip_if_mux_pin0
    SBIS    PINA,SD0
.endmacro

.macro skip_if_not_mux_pin0
    SBIC    PINA,SD0
.endmacro

.macro skip_if_mux_pin1
    SBIS    PINA,SD1
.endmacro

.macro skip_if_not_mux_pin1
    SBIC    PINA,SD1
.endmacro

.macro skip_if_mux_pin2
    SBIS    PINA,SD2
.endmacro

.macro skip_if_not_mux_pin2
    SBIC    PINA,SD2
.endmacro

.macro skip_if_mux_pin3
    SBIS    PIND,SD3
.endmacro

.macro skip_if_not_mux_pin3
    SBIC    PIND,SD3
.endmacro

.macro skip_if_mux_pin4
    SBIS    PIND,SD4
.endmacro

.macro skip_if_not_mux_pin4
    SBIC    PIND,SD4
.endmacro

.macro skip_if_mux_pin5
    SBIS    PINB,SD5
.endmacro

.macro skip_if_not_mux_pin5
    SBIC    PINB,SD5
.endmacro

.macro skip_if_mux_pin6
    SBIS    PINB,SD6
.endmacro

.macro skip_if_not_mux_pin6
    SBIC    PINB,SD6
.endmacro

.macro skip_if_mux_pin7
    SBIS    PINB,SD7
.endmacro

.macro skip_if_not_mux_pin7
    SBIC    PINB,SD7
.endmacro
