init:
; Initialise stack pointer
    LDI     temp1,high(RAMEND)
    OUT     SPH,temp1
    LDI     temp1,low(RAMEND)
    OUT     SPL,temp1
; Initialise dummy register with 0
    LDI     dummy,0
; Initialize timer 0 interrupt
    LDI     temp1,(0<<TOIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TICIE1)|(1<<TOIE0)
    OUT     TIMSK,temp1
; Set UART baud rate to 250 kbps
    LDI     temp1,1
    OUT     UBRR,temp1
reset:
; Initially disable reception
    CBI     UCR,RXEN
; Initially disable transmission
    CBI     UCR,TXEN
; Initialise input pointer
    LDI     ptr_input_h,high(input_max + 1)
    LDI     ptr_input_l,low(input_max + 1)
; Initialise output pointer
    LDI     ptr_output_h,high(output_min)
    LDI     ptr_output_l,low(output_min)
; Initially stop timer 0
    LDI     temp1,(0<<CS02)|(0<<CS01)|(0<<CS00)
    OUT     TCCR0,temp1
; Initialize timer 1 value to the maximum value as no any break occured so far
    LDI     temp1,0b11111111
    OUT     TCNT1H,temp1
    LDI     temp1,0b11111111
    OUT     TCNT1L,temp1
; Start timer 1 running at 1/1024th of clock frequency
    LDI     temp1,(0<<ICNC1)|(0<<ICES1)|(0<<CTC1)|(1<<CS12)|(0<<CS11)|(1<<CS10)
    OUT     TCCR1B,temp1
; Initialize UART
; Reception is initially disabled, it must be started using the 'R' command
; Transmission is initially disabled, it must be enabled using the 'T' command
    LDI     temp1,(1<<RXCIE)|(1<<TXCIE)|(0<<UDRIE)|(0<<RXEN)|(0<<TXEN)|(1<<CHR9)|(1<<RXB8)|(1<<TXB8)
    OUT     UCR,temp1
.ifdef mcu_8515
.include "8515init.inc"
.endif
.ifdef mcu_avrdmx
.include "avrdmxinit.inc"
.endif
; Initialize current DMX input count to 0
    MOV     current_input_count,dummy
; Initially clear merge in progress flag
    CLT
    BLD     flags,merge_in_progress
; Initialize force mux off flag to 0
    CLT
    BLD     flags,force_mux_off
; Empty DMX tables
    RCALL   reset_parameters
    RCALL   empty_input
    RCALL   read_eeprom
    reset_str_flipflop
; Enable global interrupts
    SEI
